<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: LCDLib/Source/LCDLIB.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_02de365e572d7e73aaf164675e97f837.html">LCDLib</a></li><li class="navelem"><a class="el" href="../../dir_d0db4d15118174b03f0ac10148211756.html">Source</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">LCDLIB.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d9/d6b/_l_c_d_l_i_b_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#include &lt;string.h&gt;</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &lt;stdint.h&gt;</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &quot;<a class="code" href="../../d2/ded/lcd_8h.html">lcd.h</a>&quot;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;<a class="code" href="../../de/d1b/_l_c_d_l_i_b_8h.html">LCDLIB.h</a>&quot;</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span><span class="keyword">extern</span> <span class="keywordtype">char</span> *Zone[];</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span><span class="keyword">extern</span> <span class="keyword">const</span> <a class="code hl_struct" href="../../da/dec/struct_zone_info___type_def.html">ZoneInfo_TypeDef</a> LCD_ZoneInfo[];</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span><span class="keyword">extern</span> <span class="keyword">const</span> uint16_t *Zone_TextDisplay[];</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> <span class="comment">/* end of group NANO1X2_LCDLIB_EXPORTED_VARIABLES */</span></div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab4eec8bf4978835b793764276f53f0a5">   64</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab4eec8bf4978835b793764276f53f0a5">LCDLIB_Printf</a>(uint32_t  u32Zone, <span class="keywordtype">char</span> *<span class="keywordtype">string</span>)</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>{</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keywordtype">int</span>      data, length, index;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    uint16_t bitfield;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>    uint32_t com, bit;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    <span class="keywordtype">int</span>      i;</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    length = strlen(<span class="keywordtype">string</span>);</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    index  = 0;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    <span class="comment">/* fill out all characters on display */</span></div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    <span class="keywordflow">for</span> (index = 0; index &lt; LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa75776f9baed491b8c270d419a3f6977">Sub_Zone_Num</a>; index++)</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    {</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <span class="keywordflow">if</span> (index &lt; length)</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        {</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>            data = (int) *<span class="keywordtype">string</span>;</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        <span class="keywordflow">else</span>           <span class="comment">/* padding with space */</span></div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        {</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>            data = 0x20; <span class="comment">/* SPACE */</span></div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        }</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <span class="comment">/* defined letters currently starts at &quot;SPACE&quot; - 0x20; */</span></div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        data     = data - 0x20;</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        bitfield = *(Zone_TextDisplay[u32Zone] + data);</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordflow">for</span> (i = 0; i &lt; LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>; i++)</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        {</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>            bit = *(Zone[u32Zone]</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>                    + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>                    + i*2 + 1);</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>            com = *(Zone[u32Zone]</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                    + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>                    + i*2 + 0);</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span> </div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 0);</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>            <span class="keywordflow">if</span> (bitfield &amp; (1 &lt;&lt; i))</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>            {</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>                <span class="comment">/* Turn on segment */</span></div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>                <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 1);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>            }</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        }</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <span class="keywordtype">string</span>++;</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    }</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>}</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span> </div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno"><a class="line" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa8ed043f2d8f9604ddf2aa7c2b665f1e">  122</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa8ed043f2d8f9604ddf2aa7c2b665f1e">LCDLIB_PrintNumber</a>(uint32_t  u32Zone, <span class="keywordtype">long</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a>)</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>{</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>    <span class="keywordtype">int</span>      index;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>    <span class="keywordtype">long</span> <span class="keywordtype">long</span> num, i, com, bit, div, len, tmp;</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    uint16_t bitpattern;</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a> &lt; 0)</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    {</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a> = llabs(<a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a>);</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    }</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>    <span class="comment">/* Length of number */</span></div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    len = 0;</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>    tmp = <a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a>;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>    <span class="keywordflow">while</span>( 1 )</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    {</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        <span class="keywordflow">if</span>( (tmp/10) || (tmp%10) )</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        {</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>            tmp = tmp / 10;</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>            len++;</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        }</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>    }</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    <span class="comment">/* Extract useful digits */</span></div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    div = 1;</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    <span class="comment">/* fill out all characters on display */</span></div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    <span class="keywordflow">for</span> (index = (LCD_ZoneInfo[u32Zone].Sub_Zone_Num-1); index &gt;= 0; index--)</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>    {</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        num = (<a class="code hl_variable" href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a> / div) % 10;</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        num += 16;</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        bitpattern = *(Zone_TextDisplay[u32Zone] + num);</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span> </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        <span class="keywordflow">for</span> (i = 0; i &lt; LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>; i++)</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        {</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>            bit = *(Zone[u32Zone]</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>                    + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>                    + i*2 + 1);</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>            com = *(Zone[u32Zone]</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>                    + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>                    + i*2 + 0);</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>            <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 0);</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span> </div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>            <span class="keywordflow">if</span> (bitpattern &amp; (1 &lt;&lt; i))</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>            {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>                <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 1);</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>            }</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        }</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>        div = div * 10;</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span> </div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>}</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span> </div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span> </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno"><a class="line" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf8ede697562cea379a6eb00a0157a28f">  193</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf8ede697562cea379a6eb00a0157a28f">LCDLIB_PutChar</a>(uint32_t u32Zone, uint32_t u32Index, uint8_t u8Ch)</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>{</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    <span class="keywordtype">int</span>      data, index;</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>    uint16_t bitfield;</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>    uint32_t com, bit;</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>    <span class="keywordtype">int</span>      i;</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span> </div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    index  = u32Index;</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>    data = u8Ch;</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>    <span class="keywordflow">if</span>(u32Index &gt; LCD_ZoneInfo[u32Zone].Sub_Zone_Num) <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>    <span class="comment">/* defined letters currently starts at &quot;SPACE&quot; - 0x20; */</span></div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    data     = data - 0x20;</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>    bitfield = *(Zone_TextDisplay[u32Zone] + data);</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span> </div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    <span class="keywordflow">for</span> (i = 0; i &lt; LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>; i++)</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>    {</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        bit = *(Zone[u32Zone]</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>                + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>                + i*2 + 1);</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span> </div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>        com = *(Zone[u32Zone]</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>                + index*LCD_ZoneInfo[u32Zone].<a class="code hl_variable" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">Zone_Digit_SegNum</a>*2</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>                + i*2 + 0);</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 0);</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span> </div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        <span class="keywordflow">if</span> (bitfield &amp; (1 &lt;&lt; i))</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        {</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>            <span class="comment">/* Turn on segment */</span></div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>            <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 1);</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>        }</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>    }</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span> </div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>}</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span> </div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno"><a class="line" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gabcca43be459440650558de1c0e556fb3">  242</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gabcca43be459440650558de1c0e556fb3">LCDLIB_SetSymbol</a>(uint32_t u32Zone, uint32_t u32Index, uint32_t u32OnOff)</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>{</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>    uint32_t com, bit;</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span> </div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>    bit = *(Zone[u32Zone] + u32Index*2 + 1);</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span> </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>    com = *(Zone[u32Zone] + u32Index*2 + 0);</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span> </div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>    <span class="keywordflow">if</span> (u32OnOff)</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 1); <span class="comment">/* Turn on segment */</span></div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        <a class="code hl_function" href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a>(com, bit, 0); <span class="comment">/* Turn off segment */</span></div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span> </div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>}</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span> <span class="comment">/* end of group NANO1X2_LCDLIB_EXPORTED_FUNCTIONS */</span></div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span> <span class="comment">/* end of group NANO1X2_LCDLIB_Driver */</span></div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span> <span class="comment">/* end of group NANO1X2_Library */</span></div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span> </div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span><span class="comment">/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/</span></div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
<div class="ttc" id="a_l_c_d_l_i_b_8h_html"><div class="ttname"><a href="../../de/d1b/_l_c_d_l_i_b_8h.html">LCDLIB.h</a></div><div class="ttdoc">Nano 102/112 series LCDLIB header file.</div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga38931e2f60a5bca8527b78604644e67a"><div class="ttname"><a href="../../d3/d2d/group___n_a_n_o1_x2___l_c_d___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga38931e2f60a5bca8527b78604644e67a">LCD_SetPixel</a></div><div class="ttdeci">void LCD_SetPixel(uint32_t u32Com, uint32_t u32Seg, uint32_t u32OnFlag)</div><div class="ttdoc">Enables a segment on the LCD display.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/def/lcd_8c_source.html#l00062">lcd.c:62</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga3cf84831379351ebe54dbe1ab63db86d"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3cf84831379351ebe54dbe1ab63db86d">ZoneInfo_TypeDef::Zone_Digit_SegNum</a></div><div class="ttdeci">uint32_t Zone_Digit_SegNum</div><div class="ttdoc">Segment number.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d1b/_l_c_d_l_i_b_8h_source.html#l00036">LCDLIB.h:36</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa75776f9baed491b8c270d419a3f6977"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa75776f9baed491b8c270d419a3f6977">ZoneInfo_TypeDef::Sub_Zone_Num</a></div><div class="ttdeci">uint32_t Sub_Zone_Num</div><div class="ttdoc">Sub zone number.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d1b/_l_c_d_l_i_b_8h_source.html#l00035">LCDLIB.h:35</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa8ed043f2d8f9604ddf2aa7c2b665f1e"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa8ed043f2d8f9604ddf2aa7c2b665f1e">LCDLIB_PrintNumber</a></div><div class="ttdeci">void LCDLIB_PrintNumber(uint32_t u32Zone, long long value)</div><div class="ttdoc">Display number on LCD.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d6b/_l_c_d_l_i_b_8c_source.html#l00122">LCDLIB.c:122</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gab4eec8bf4978835b793764276f53f0a5"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab4eec8bf4978835b793764276f53f0a5">LCDLIB_Printf</a></div><div class="ttdeci">void LCDLIB_Printf(uint32_t u32Zone, char *string)</div><div class="ttdoc">Display text on LCD.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d6b/_l_c_d_l_i_b_8c_source.html#l00064">LCDLIB.c:64</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gabcca43be459440650558de1c0e556fb3"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gabcca43be459440650558de1c0e556fb3">LCDLIB_SetSymbol</a></div><div class="ttdeci">void LCDLIB_SetSymbol(uint32_t u32Zone, uint32_t u32Index, uint32_t u32OnOff)</div><div class="ttdoc">Display symbol on LCD.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d6b/_l_c_d_l_i_b_8c_source.html#l00242">LCDLIB.c:242</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaf8ede697562cea379a6eb00a0157a28f"><div class="ttname"><a href="../../d0/d1c/group___n_a_n_o1_x2___l_c_d_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf8ede697562cea379a6eb00a0157a28f">LCDLIB_PutChar</a></div><div class="ttdeci">void LCDLIB_PutChar(uint32_t u32Zone, uint32_t u32Index, uint8_t u8Ch)</div><div class="ttdoc">Display character on LCD.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d6b/_l_c_d_l_i_b_8c_source.html#l00193">LCDLIB.c:193</a></div></div>
<div class="ttc" id="alcd_8h_html"><div class="ttname"><a href="../../d2/ded/lcd_8h.html">lcd.h</a></div><div class="ttdoc">Nano102/112 series LCD driver header file.</div></div>
<div class="ttc" id="asemihosting_8h_html_aacce635d68067370c70caa2381ea1040"><div class="ttname"><a href="../../d5/d32/semihosting_8h.html#aacce635d68067370c70caa2381ea1040">value</a></div><div class="ttdeci">return value</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d32/semihosting_8h_source.html#l00098">semihosting.h:98</a></div></div>
<div class="ttc" id="astruct_zone_info___type_def_html"><div class="ttname"><a href="../../da/dec/struct_zone_info___type_def.html">ZoneInfo_TypeDef</a></div><div class="ttdef"><b>Definition:</b> <a href="../../de/d1b/_l_c_d_l_i_b_8h_source.html#l00033">LCDLIB.h:34</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:30 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
